	device zxspectrum128
        ORG #6000
begin
	di
;	jr $
;	ld c,(hl)
;	ld a,(bc)
;	ld (hl),a
;	inc hl
;	inc b
;	ld hl,$5800,de,$5801,bc,767,(hl),$46:ldir
	ld hl,$5800,b,32
fila: ld (hl),$46:inc hl:djnz fila
	ld hl,$4444,($5800),hl,($581E),hl

	ld hl,$5800,de,$5820,bc,768-32:ldir

	ld hl,$5922
	ld c,6
fa1:
	push hl
	ld b,28
fa2:
	ld (hl),$45
	inc hl
	djnz fa2
	pop hl
	ld de,32
	add hl,de
	dec c
	jr nz,fa1

fop equ $B700
;form font
	ld hl,fop
	ld de,fnt
ff:
	push hl
	ld a,l
	inc a
	and 63
	ld (hl),a
	inc h
	ld b,8
f8:
	ld a,(de),(hl),a
	inc h,de
	djnz f8
	pop hl
	inc l
	bit 6,l
	jr z,ff

	ld a,$10,bc,$7ffd:out (c),a
	ld hl,song:call INIT
;form bars stack
	ld hl,ob
	ld b,0
fo1:
	ld (hl),$E1:inc hl
	ld (hl),$22:inc hl
	ld a,b
	call py2saddr
	ld (hl),e:inc hl
	ld (hl),d:inc hl

	ld a,191:sub b
	call py2saddr
	ld a,e:or 30:ld e,a
	ld (hl),$22:inc hl
	ld (hl),e:inc hl
	ld (hl),d:inc hl
	inc b
	ld a,b
	cp 192
	jp nz,fo1
;end of stack
	ld (hl),$31:inc hl
	ld (outb+2),hl
	inc hl,hl
	ld (hl),$C9:inc hl
;
	ld sp,$5FE0
	di
	ld a,$5E,i,a
	im 2
	ld hl,intvec,($5EFF),hl

chp=$B000
	ld hl,fta+192,de,chp,bc,192:ldir
zu:
	ei:halt
	ld a,0:out ($FE),a

bac: ld a,-1
	inc a
	ld (bac+1),a
	and 3-2
	jr nz,skipb

bco: ld a,0
	inc a
	cp 14
	jr nz,nobarlp
	xor a
nobarlp:
	ld (bco+1),a
skipb:
	ld a,(bco+1)
	ld l,0,h,a
;*192=128+64
	srl h:rr l
	ld de,hl
	srl h:rr l
	add hl,de
;*2
	add hl,hl
	ld de,bar
	add hl,de
	call outb

;	ld a,1:out ($FE),a
	ld hl,$4800:call ous
;	ld a,5:out ($FE),a
	ld hl,$5800:call ous
;	ld a,0:out ($FE),a
;	ld a,2:out ($FE),a
;check keys
	ld a,$F7:in a,($FE)
	ld c,1,hl,fta:rra:jr nc,putd
	ld c,2,hl,fta+192:rra:jr nc,putd
	ld c,3,hl,fta+192*2:rra:jr nc,putd
	ld c,4,hl,fta+192*3:rra:jr nc,putd
	jp nokeys
putd:
	ld a,c
pd:	cp 2: jp z,nokeys
	ld (pd+1),a
	ld de,chp,bc,192:ldir

nokeys:
	call char

sc: ld a,0
	inc a
	ld (sc+1),a
	and 3-2
	jp nz,zu

smc: ld a,-1
	inc a
	cp 14
	jr nz,noloopsm
	xor a
noloopsm:
	ld (smc+1),a
	ld l,a,h,0
	ld de,smile
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	ld de,smb+32
	ld b,32
copysm:
	ld a,(hl),(de),a:inc hl,de
	ld a,(hl),(de),a:inc hl
	dec de,de,de
	djnz copysm
	jp zu
;**********************************************
char:
	ld de,#4802+32
	ld hl,chp;fta+192

 dup 6
 
 dup 28
 	ld b,fop/256
 	ld c,(hl)
 	ld a,(bc)
 	ld (hl),a
 	inc hl
 	inc b
 	ld a,d:exa
 dup 8
 	ld a,(bc),(de),a
 	inc b,d
edup;8
	exa:ld d,a
	inc e
edup;28
	inc e,e,e,e
	inc hl,hl,hl,hl
edup;6

	ret
;**********************************************
fnt:incbin "4400.002"
fta:incbin "67a9.bin"

smile: incbin "smile2.bin"
smb: ds 34
sts: dw $4800
ous: ld (backsp+1),sp
	dec hl,hl
	ld (sts),hl
	ld sp,(sts)
n=0
 dup 8
	ld hl,(smb+n)
	ld de,(smb+16+n)

 dup 4
 
 dup 14
 push hl
edup
 dec sp,sp
 dec sp,sp

 dup 14
 push de
edup
 dec sp,sp
 dec sp,sp

edup ;4

n=n+2
edup ;8

backsp: ld sp,0
	ret

py2saddr:
	push hl
	ld l,a
;	ld a,l
	and $07
	ld h,a
	ld a,l
	and $c0
	rra
	inc a
	rrca
	rrca
	or h
	ld h,a
	ld a,l
	add a
	add a
	and $e0
	ld l,a
	ex de,hl
	pop hl
	ret

intvec:
	push ix,iy
	push hl,de,bc,af
	exx:exa
	push hl,de,bc,af

;pa:	ld a,$10
;	and 8
;	or $11
;	ld bc,$7FFD:out (c),a
	call PLAY
;	call c_tr
;	ld a,(pa+1)
;	ld bc,$7FFD:out (c),a

	pop af,bc,de,hl
	exx:exa
	pop af,bc,de,hl
	pop iy,ix
	ei:ret

bar: incbin "bars.bin"
outb: ld (0),sp
	ld sp,hl
ob:
end
	page 0
	org $C000
pg0b:
plyr:include "PTxPlay.a80"
song:incbin "CF_tune.pt3"
pg0e:
	display end
	display /d,end-begin
	savesna "!void.sna",begin
	savebin "demo.code",begin,end-begin
	page 0
	savebin "pg1.code",pg0b,pg0e-pg0b
